// Second program with constants and helper functions
// demonstrating primitive parameters

// In the code below there are
//     - 4 different syntax errors and
//     - 1 semantic error

// Study the code 
//    - to understand its functioning
//    - to answer the questions (what is it? -> name each) and
//      fill the blanks _____________________
//    - to identify its five errors


// imports would be HERE
//   everything else in class, in between { }
//

class Prog2 {
   
   // what are they? 
   // class constants
   // their scope = entire class; final means should not be changed (l. 31)
   public static final double PI = 3.14;
   public static final char LINE_SYMBOL = '*';
   
   
   
   // what is it? 
   // an helper method
   public static double circlePerimeter(double r) {
      // PI = 3.1;           // CAN'T due to final
      return 2 * PI * r;   
   }
   
   
   // r is a formal parameter
   public static double circleArea(double r) {
      
      System.out.println("1. circleArea value " + r);
      r = squareMe(r);
      System.out.println("2. circleArea value " + r);
      
      return PI * r;
      
      
   }
   
   public static double squareMe(double f) {
      System.out.println("1. squareMe value " + f);
      f = f * f;
      System.out.println("2. squareMe value " + f);
      
      return f;   
   }
   
   // for loop syntax 
   public  static   void printManyChar(int m, char c) {
      
      for (int i = 0; i<m; i++) 
         System.out.print(c);
      
      
      System.out.println();            
   }
   
   
   public static void main(String[] args) {
      
      double radius = 2.0;  
      
      double perim = circlePerimeter(radius);
      
      // radius is an actual parameter
      double area = circleArea(radius);
      
      printManyChar(30, LINE_SYMBOL);
      
      System.out.println("A circle of radius " +  radius + " has");
      System.out.println("  - a perimeter of " +  perim);
      System.out.println("  - an area of " +  area);
      
      printManyChar(30, LINE_SYMBOL);
   }
   
}






// Our in-class process. One thing at a time



// Fixed 4 syntax errors
//   








// then semantic problem





// Testing
// Give radius 2.0 (weird, but better than 1 for debug) 
//                  -> does it make sense?
// Show radius 1.0 
//        then 3.0



// Learning outcomes
// 1. parameters vocabulary
// 2. primitive as param:
//       - value is copied thus
//         change not persistent across function call 
//  (local change doesn't influence the variable whose value was copied)
//        ---> need RETURN
// 3. scope

